/*
 * Created on 09.03.2004
 * LesenAllerheaderClient
 *
*/
package theorie;

import java.util.Enumeration;
import java.util.Properties;

import javax.mail.Folder;
import javax.mail.Header;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.URLName;

/**
 * Lesen aller Header
 *
 */

public class LesenAllerHeaderClient {

	private static final String URL = "imap://jjoller@imap.hsr.ch/INBOX";
	public static void main(String[] args) {
		System.out.println("[LesenAllerHeaderClient]main()");
		String mail_url;
		if (args.length == 0) {
			System.err.println(
				"Usage: java LesenAlerlHeaderClient protocol://username@host:port/foldername");
			//return;
			mail_url = URL;
		} else {
			mail_url = URL;
		}
		System.out.println("[LesenAllerHeaderClient.main()]Mail URL : "+mail_url);
		URLName server = new URLName(mail_url);
		try {
			System.out.println("[LesenAllerHeaderClient.main()]Session erffnen");
			Session session =
				Session.getDefaultInstance(
					new Properties(),
					new MailAuthenticator(server.getUsername()));

			// Verbindungsaufbau
			System.out.println("[LesenAllerHeaderClient.main()]Folder ffnen");
			Folder folder = session.getFolder(server);
			if (folder == null) {
				System.out.println(
					"\tFolder " + server.getFile() + " nicht gefunden.");
				System.exit(1);
			}
			folder.open(Folder.READ_ONLY);

			// Lesen der Nachrichten
			System.out.println("[LesenAllerHeaderClient.main()]Messages lesen");
			Message[] messages = folder.getMessages();
			for (int i = 0; i < messages.length; i++) {
				System.out.println(
					"------------ Message " + (i + 1) + " ------------");
				// Unterschied
				Enumeration headers = messages[i].getAllHeaders();
				while (headers.hasMoreElements()) {
					Header h = (Header) headers.nextElement();
					System.out.println(h.getName() + ": " + h.getValue());
				}
				System.out.println();
			}
			// Verbindungsabbau
			// Nachrichten bleiben auf dem Server
			System.out.println("[LesenAllerHeaderClient.main()]Folder schliessen");			
			folder.close(false);

		} catch (Exception e) {
			e.printStackTrace();
		}

		// GUI herunterfahren
		// exit
		System.exit(0);
		System.out.println("[LesenAllerHeaderClient.main()]Ende");
	}
}